您的位置:首页 > 产品设计 > UI/UE

LeetCode Unique Paths

2015-09-13 07:47 399 查看
原题链接在这里:https://leetcode.com/problems/unique-paths/

A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

How many possible unique paths are there?



Above is a 3 x 7 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

若从DP角度考虑这个问题就是需保存历史数据为走到当前格子的不同路径数,用二维数组res保存。

更新当前点res[i][j]为上一行同列res[i-1][j]的值 + 本行上一列res[i][j-1]的值,因为走到上一行同列的值想走到当前格都是往下走一步,左边同理。

初始条件是第一行和第一列都是1.

Time Complexity: O(m*n). Space: O(m*n).

AC Java:

public class Solution {
public int uniquePaths(int m, int n) {
if(m == 0 || n == 0){
return 0;
}
int [][] dp = new int[m]
;
for(int i = 0; i<m; i++){
dp[i][0] = 1;
}
for(int j = 0; j<n; j++){
dp[0][j] = 1;
}
for(int i = 1; i<m; i++){
for(int j = 1; j<n; j++){
dp[i][j] = dp[i-1][j] + dp[i][j-1];
}
}
return dp[m-1][n-1];
}
}


存储历史信息可以用一维数组完成从而节省空间。生成一个长度为n的数组res, 每次更新res[j] += res[j-1], res[j-1]就是同行前一列的历史结果,res[j]为更新前是同列上一行的结果,所以res[j] += res[j-1]就是更新后的结果。

Note:外层loop i 从0开始,dp[0] = 1, 相当于初始了第一列,所以i=0开始要初始第一行

Time Complexity: O(m*n). Space: O(n).

public class Solution {
public int uniquePaths(int m, int n) {
if(m == 0 || n == 0){
return 0;
}
int [] dp = new int
;
dp[0] = 1;
for(int i = 0; i<m; i++){
for(int j = 1; j<n; j++){
dp[j] += dp[j-1];
}
}
return dp[n-1];
}
}


有进阶版题目Unique Paths II.
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: